#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
mbt_01.py
"""

import sys
import serial
from time import sleep
from crc16c import calcByte,calcString,hexCRC,checkModbusWithCrc,readHex
from threading import Timer
import keyboard # Cal ser root per a que funcioni 

class ModBus():
	def __init__(self, parent=None):
		
		if len( sys.argv ) == 2 :
			szPort = sys.argv[1]
			nBauds = 115200
		else :
			if len( sys.argv ) == 3 :
				szPort = sys.argv[1]
				nBauds = int(sys.argv[2])
			else :
				szPort = "/dev/ttyUSB0"
				nBauds = 115200

		#port='/dev/ttyUSB0'
		#baudrate = 9600
		port = szPort
		baudrate = nBauds
		
		print("Baudrate: %d at %s"%(baudrate,port))
		self.ser = 0
		self.t = 0
		
		try: 	
			self.ser = serial.Serial(
				port,
				baudrate,
				timeout=0,
				parity=serial.PARITY_NONE,
				stopbits=serial.STOPBITS_TWO,
				bytesize=serial.EIGHTBITS
			)
			
			self.t = Timer(2,self.temporitzador)
			self.t.start()
			while True:
				#sleep(0.1)
				if keyboard.is_pressed('q'):  # if key 'q' is pressed 
					print('You Pressed A Key!')
					break  # finishing the loop
				else:
					pass

		except serial.SerialException as e:
			print ("%s port is not connected" % szPort)
			sys.exit(-1)
		"""		
		except KeyboardInterrupt:
			print ("\nAdéu!")
			self.t.cancel()		
			sys.exit(0)
		"""		

	def __del__(self):
		if self.t:
			self.t.cancel()	
		if self.ser:
			self.ser.close()
		sys.exit(0)
					
	def temporitzador(self):
		print("Crida al temporitzador")
		self.t = Timer(2,self.temporitzador)
		self.t.start()
			
if __name__ == '__main__':

	mb = ModBus()
